// 
sbit lcd_rs          at ra5_bit; sbit lcd_rs_direction          at trisa5_bit;
sbit lcd_en          at ra4_bit; sbit lcd_en_direction          at trisa4_bit;
sbit lcd_d4          at ra0_bit; sbit lcd_d4_direction          at trisa0_bit;
sbit lcd_d5          at ra1_bit; sbit lcd_d5_direction          at trisa1_bit;
sbit lcd_d6          at ra2_bit; sbit lcd_d6_direction          at trisa2_bit;
sbit lcd_d7          at ra3_bit; sbit lcd_d7_direction          at trisa3_bit;
// VS1053
sbit vrs             at rc0_bit; sbit vrs_direction             at trisc0_bit; //xRESET
sbit vdq             at rd1_bit; sbit vdq_direction             at trisd1_bit; //DREQ
sbit vbc             at rd2_bit; sbit vbc_direction             at trisd2_bit; //xDCS/BSYNC
sbit vcs             at rd3_bit; sbit vcs_direction             at trisd3_bit; //xCS
//  CS SD 
sbit mmc_chip_select at rc7_bit; sbit mmc_chip_select_direction at trisc7_bit;
//   RD4    
//  EEPROM 24LC02B
sbit soft_i2c_scl    at rd5_bit; sbit soft_i2c_scl_direction    at trisd5_bit;
sbit soft_i2c_sda    at rd6_bit; sbit soft_i2c_sda_direction    at trisd6_bit;

unsigned long rz1,rz2,i3,rzp,rzs;
//rz1,rz2-  (   SD )   ( )
//i3-       SD 
//rzp-  
//rzs-   ()
unsigned gro,zt,sso,sl,rzd,nb1;
//gro-   (   )
//zt-        
//sso-    
//sl-    (  "")
//rzd-   
//nb1-   
unsigned short i1,i2,ntr1,ntr2,ntr3,ntr4[250],ktr,au[512],tm1,rp,rg1,rg2;
//i1,i2-   
//ntr1- 
//ntr2,ntr3-  
//ntr4[]-   
//ktr- 
//au[]-   (     )
//rp- 
//tm1-   (~0,5 )
//rg1,rg2-   vs1053
unsigned short pd1,mma,ssa,tma1,mmp,ssp,grs1,grs2,av1,am1,bl1,grn,kp1,kp2;
//pd1-   
//mma,ssa- 
//tma1-     
//mmp,ssp-  
//grs1,grs2-   
//av1,am1-    
//bl1- 
//grn-
//kp1-      
//kp2-   "/"
unsigned short ssv1,ssv2,nb2,emk;
//ssv1,ssv2-    
//nb2-     
//emk-   
char tx1[4],tx2[13],naz[2000],dir[9],im1[40],im2[40];
//tx1[]-    
//tx2[]-  
//naz[]-   ( 250   8 )
//dir[]- 
//im1[]-  (ID3v1)
//im2[]-  (ID3v1)
bit cd,p1,p2,p3,st1,gr1,gr2;
//cd-   
//p1,p2,p3-    
//st1-/  
//gr1-  
//gr2-   
bit nkn,pd2,dct,tma2,av2,am2,a1,bl2,ssv3,ob1,zr1,a2,a3,dl1;
//nkn-  
//pd2- 
//dct-    
//tma2-    
//av2,am2,a1-  
//bl2-   
//ssv3-  
//ob1-    
//zr1-   
//a2,a3-   
//dl1-  
const unsigned short bitr[14]={4,5,6,7,8,10,12,14,16,20,24,28,32,40}; //   (    1000   )   8

const char hds[]= //       (        )
{
0x41,0xa0,0x42,0xa1,0xe0,0x45,0xa3,0xa4,0xa5,0xa6,0x4b,0xa7,0x4d,0x48,0x4f,0xa8, // 
0x50,0x43,0x54,0xa9,0xaa,0x58,0xe1,0xab,0xac,0xe2,0xad,0xae,0x00,0xaf,0xb0,0xb1, // 
0x61,0xb2,0x01,0xb4,0xe3,0x65,0xb6,0xb7,0xb8,0xa6,0x06,0xbb,0xbc,0xbd,0x6f,0xbe, // 
0x70,0x63,0xbf,0x79,0x02,0x78,0xe5,0xc0,0xc1,0xe6,0xc2,0xc3,0x03,0xc5,0xc6,0xc7  // 
// ",,,,"     0x00,0x01,0x06,0x02,0x03
// ","     ,  ","   0xa2,0xb5
};

void interrupt() //    0
{
if (tmr0if_bit==1)
{
tm1++; sl++; if (tm1>3) {tm1=0; tma1++; tma2=1; dct=1; if (dl1==0) ssv2++; nb2++;} nkn=1; tmr0if_bit=0; tmr0h=0xf0; tmr0l=0x5f;
if (pd2==1 && ssv1<10) {pd1++; portb.b3=1; ssv2=0;} if (pd1>70) {pd1=0; portb.b3=0; pd2=0;} /// 
}
}

void znak() //       
{
for (i1=80; i1<121; i1=i1+8)
{
tx2[7]=0;
if (i1==80)  {tx2[0]=4;  tx2[1]=14; tx2[2]=31; tx2[3]=0;  tx2[4]=4;  tx2[5]=14; tx2[6]=31;} // " "        ( 0x02)
if (i1==88)  {tx2[0]=4;  tx2[1]=14; tx2[2]=31; tx2[3]=0;  tx2[4]=31; tx2[5]=14; tx2[6]=4;}  // ""          ( 0x03)
if (i1==96)  {tx2[0]=31; tx2[1]=14; tx2[2]=4;  tx2[3]=0;  tx2[4]=4;  tx2[5]=14; tx2[6]=31;} // ""         ( 0x04)
if (i1==104) {tx2[0]=0;  tx2[1]=0;  tx2[2]=0;  tx2[3]=0;  tx2[4]=0;  tx2[5]=0;  tx2[6]=0;}  //   ( 0x05)
if (i1==112) {tx2[0]=0;  tx2[1]=0;  tx2[2]=17; tx2[3]=18; tx2[4]=28; tx2[5]=18; tx2[6]=17;} // ""                ( 0x06)
if (i1==120) {tx2[0]=14; tx2[1]=17; tx2[2]=17; tx2[3]=17; tx2[4]=17; tx2[5]=17; tx2[6]=31;} //  ()    ( 0x07)
lcd_cmd(i1); for (i2=0; i2<8; i2++) lcd_chr_cp(tx2[i2]); // 
lcd_cmd(_lcd_return_home); //   
}
}

void vs1053rd(unsigned short adr1) // 2    vs1053
{
vcs=0;
spi1_write(0x03); //  
spi1_write(adr1); // 
rg2=spi1_read(0); // 
rg1=spi1_read(0); // 
vcs=1; 
while (vdq==0); //    DREQ (vs1053)   1
}

void vs1053wrn(unsigned short adr, unsigned dt) //    vs1053
{
vbc=1; vcs=0;
spi1_write(0x02);  //  
spi1_write(adr);   // 
spi1_write(dt>>8); // 
spi1_write(dt<<0); // 
vcs=1;
while (vdq==0);
}

void vs1053in() // vs1053
{
vcs=1; vrs=1; vbc=0;
spi1_init_advanced(_spi_master_osc_div16,_spi_data_sample_middle,_spi_clk_idle_low,_spi_low_2_high); // SPI1  
vrs=0; delay_ms(10); vrs=1; // vs1053
while (vdq==0);
vs1053wrn(0x00,0x8808); //   2 ( )    ( SCI_MODE)
vs1053wrn(0x02,0x7a00); // SCI_BASS
vs1053wrn(0x03,0x2000); //   2 ( SCI_CLOCKF)
}

void vs1053wr1 (unsigned short bit1)      {vcs=1; vbc=0; while (vdq==0); spi1_write(bit1); vbc=1;}                              // 1   vs1053
void vs1053wr32(unsigned short bit32[32]) {vcs=1; vbc=0; while (vdq==0); for (i1=0; i1<32; i1++) spi1_write(bit32[i1]); vbc=1;} // 32   vs1053

void perek() // 
{
ob1=0;
if (p1==1) 
{
if (rp==0) {ntr1++; if (ntr1>ktr) ntr1=1; ob1=1;} //  
if (rp==1) // 
{
ob1=1; if (ktr<3) {ntr1++; if (ntr1>ktr) ntr1=1;}
else {ntr2++; if (ntr2>249) ntr2=0; if (ntr3<ntr2) {srand(sl); ntr1=(rand()%ktr)+1; ntr3++; if (ntr3>249) ntr3=0; ntr4[ntr2]=ntr1;} else ntr1=ntr4[ntr2];}
}//rp=2 -   (    )
}

if (p2==1 && sso<3) 
{
if (rp==0) {ntr1--; if (ntr1==0) ntr1=ktr; ob1=1;}
if (rp==1) {if (ktr<3) {ntr1--; if (ntr1==0) ntr1=ktr;} else {ntr2--; if (ntr2==255) ntr2=0; ntr1=ntr4[ntr2];} ob1=1;}
}
p1=0; p2=0; tm1=0; rz1=0; rz2=0;
}

void stroka(unsigned short nm) {for (i1=0; i1<12; i1++) lcd_chr(nm,i1+1,tx2[i1]);} //   

void znakgr(unsigned short tnm) //  (    0x05)
{
const unsigned short er1[]={110,110,109,109,108,108,108,107,107,107,107,106,106,106,106,106,105,105,105,105,105,104,104,104,104,104};
const unsigned short er2[]={  0,  1,  1,  3,  1,  3,  7,  1,  3,  7, 15,  1,  3,  7, 15, 31,  1,  3,  7, 15, 31,  1,  3,  7, 15, 31};
unsigned short cm1,cm2;

cm1=er1[tnm]; cm2=er2[tnm];
if (tnm==1)  {lcd_cmd(109); lcd_chr_cp(0);} if (tnm==3)  {lcd_cmd(108); lcd_chr_cp(0);}
if (tnm==6)  {lcd_cmd(107); lcd_chr_cp(0);} if (tnm==10) {lcd_cmd(106); lcd_chr_cp(0);}
if (tnm==15) {lcd_cmd(105); lcd_chr_cp(0);} if (tnm==20) {lcd_cmd(104); lcd_chr_cp(0);}
lcd_cmd(cm1); lcd_chr_cp(cm2);
}

void znakbat(unsigned short emk3) //   (    0x07)
{
const unsigned short emk1[]={17,17,17,17,17, 17,17,17,17,31, 17,17,17,31,31, 17,17,31,31,31, 17,31,31,31,31, 31,31,31,31,31};
const unsigned short emk2[]={17,21,31,21,17};
if (nb1>775) nb1=775; emk=775-nb1;
if (emk<21)  i2=25; //100%
if (emk>20)  i2=20; //80%
if (emk>40)  i2=15; //60%
if (emk>60)  i2=10; //40%
if (emk>80)  i2=5;  //20%
if (emk>100) i2=0;  //0%
emk=i2; lcd_cmd(121); if (emk3==0) {for (i2=emk; i2<emk+5; i2++) lcd_chr_cp(emk1[i2]);} else {for (i2=0; i2<5; i2++) lcd_chr_cp(emk2[i2]);}
//-775( )  -655( )
}

void znakvsp() // ""  ""
{
tx2[7]=0;
for (i1=64; i1<73; i1=i1+8)
{
if (st1==1)
{
if (i1==64)  {tx2[0]=3;  tx2[1]=3;  tx2[2]=3;  tx2[3]=3;  tx2[4]=3;  tx2[5]=3;  tx2[6]=3;}  // "."   ( 0x00)
if (i1==72)  {tx2[0]=24; tx2[1]=24; tx2[2]=24; tx2[3]=24; tx2[4]=24; tx2[5]=24; tx2[6]=24;} // "."   ( 0x01)
}
else
{
if (i1==64)  {tx2[0]=2;  tx2[1]=3;  tx2[2]=3;  tx2[3]=3;  tx2[4]=3;  tx2[5]=3;  tx2[6]=2;}  // ""    ( 0x00)
if (i1==72)  {tx2[0]=0;  tx2[1]=0;  tx2[2]=16; tx2[3]=24; tx2[4]=16; tx2[5]=0;  tx2[6]=0;}  // ""    ( 0x01)
}
lcd_cmd(i1); for (i2=0; i2<8; i2++) lcd_chr_cp(tx2[i2]); lcd_cmd(_lcd_return_home);
}
}

void znakbl() //  
{
if (bl1==10) {lcd_chr(1,10,0x42); lcd_chr(1,11,0xe1); tx2[9]=0x42; tx2[10]=0xe1;}
if (bl1<10)  {bytetostr(bl1,tx1); lcd_chr(1,10,0xa7); lcd_chr(1,11,tx1[2]); tx2[9]=0xa7; tx2[10]=tx1[2];}
if (bl1>10)  {i2=20-bl1; bytetostr(i2,tx1); lcd_chr(1,10,0xa8); lcd_chr(1,11,tx1[2]); tx2[9]=0xa8; tx2[10]=tx1[2];}
}

void menu0() //  
{
dct=0; znakbat(zr1); tx2[11]=0x07; //  
bytetostr(ntr1,tx1);
if (ntr1<10)            {tx2[0]=tx1[2]; tx2[1]=0x28;}
if (ntr1>9 && ntr1<100) {tx2[0]=tx1[1]; tx2[1]=tx1[2]; tx2[2]=0x28;}
if (ntr1>99)            {tx2[0]=tx1[0]; tx2[1]=tx1[1]; tx2[2]=tx1[2]; tx2[3]=0x28;}
bytetostr(ktr,tx1);
if (ktr<10)                           {tx2[2]=tx1[2]; tx2[3]=0x29;   tx2[4]=0x20;   tx2[5]=0x20; tx2[6]=0x20; tx2[7]=0x20;}
if (ktr>9 && ktr<100 && tx2[1]==0x28) {tx2[2]=tx1[1]; tx2[3]=tx1[2]; tx2[4]=0x29;   tx2[5]=0x20; tx2[6]=0x20; tx2[7]=0x20;}
if (ktr>99 && tx2[1]==0x28)           {tx2[2]=tx1[0]; tx2[3]=tx1[1]; tx2[4]=tx1[2]; tx2[5]=0x29; tx2[6]=0x20; tx2[7]=0x20;}
if (ktr>9 && ktr<100 && tx2[2]==0x28) {tx2[3]=tx1[1]; tx2[4]=tx1[2]; tx2[5]=0x29;   tx2[6]=0x20; tx2[7]=0x20;}
if (ktr>99 && tx2[2]==0x28)           {tx2[3]=tx1[0]; tx2[4]=tx1[1]; tx2[5]=tx1[2]; tx2[6]=0x29; tx2[7]=0x20;}
if (ktr>99 && tx2[3]==0x28)           {tx2[4]=tx1[0]; tx2[5]=tx1[1]; tx2[6]=tx1[2]; tx2[7]=0x29;}
tx2[8]=0x20;
tx2[9]=rp+2;  //  
tx2[10]=0x05; // 
if (bl2==1) znakbl();
stroka(1);

znakvsp(); tx2[5]=0x00; tx2[6]=0x01; // /
bytetostr(mmp,tx1); if (tx1[1]==0x20) tx1[1]=0x30; tx2[0]= tx1[1];tx2[1]= tx1[2];
bytetostr(ssp,tx1); if (tx1[1]==0x20) tx1[1]=0x30; tx2[3]= tx1[1];tx2[4]= tx1[2];
bytetostr(mma,tx1); if (tx1[1]==0x20) tx1[1]=0x30; tx2[7]= tx1[1];tx2[8]= tx1[2];
bytetostr(ssa,tx1); if (tx1[1]==0x20) tx1[1]=0x30; tx2[10]=tx1[1];tx2[11]=tx1[2];
tx2[2]=0x3a; tx2[9]=0x3a;
stroka(2);
}

void printchar(char ktrp) //            
{
if (a2==1) {if (ktrp=='D' && i1==3) a3=1; if (i1>38 && ktrp!=10 && ktrp!=13 && a3==1) dir[i1-39]=ktrp; i1++; if (ktrp==10) i1=0;}
else
{
au[i1]=ktrp; if (ktrp==10) i1=0;
if (ktrp=='3' && i1>2) {if (au[i1-1]=='P' && au[i1-2]=='M' && au[i1-3]=='.' && a3==1) {ktr++; for (i2=0; i2<8; i2++) naz[7+zt-i2]=au[i1-i2-4]; i1=0; zt=zt+8;}}
i1++; if (ktr>249) a3=0; //    250,   
}
}

void prib() //  /
{
if (a1==1) {vs1053wrn(0x0b,0xfefe); vs1053wrn(0x00,0x8808); a1=0;} rz1=rz2-rzs*sso;
if (av2==1) {i2=av1-9; rz1=rz1-rzs*i2; if (rz1>rz2) rz1=1000; sso=sso+i2; if (sso>rzd) sso=rzd;}
if (am2==1) {i2=am1-9; rz1=rz1+rzs*i2; if (rz1>rz2) rz1=rz2;  sso=sso-i2; if (sso>rzd) sso=0;}
rzp=rz2-rz1;
mmp=sso/60;     bytetostr(mmp,tx1); if (tx1[1]==0x20) tx1[1]=0x30; lcd_chr(2,1,tx1[1]); lcd_chr(2,2,tx1[2]);
ssp=sso-mmp*60; bytetostr(ssp,tx1); if (tx1[1]==0x20) tx1[1]=0x30; lcd_chr(2,4,tx1[1]); lcd_chr(2,5,tx1[2]);
delay_ms(400);
}

void f1() {znakbat(zr1); lcd_chr(1,12,0x07); vs1053wrn(0x04,sso); mmc_fat_seek(rzp); gr2=1; zt=0xfefe; vs1053wrn(0x00,0x8800); tma1=38;} // 

void gromk() //   
{
i1=bl1; if (i1>10) i1=10; i2=20-bl1; if (i2>10) i2=10; i1=100-(i1*grn/10); if (i1==100) i1=254; i2=100-(i2*grn/10); if (i2==100) i2=254;
gro=(i1<<8)+i2; vs1053wrn(0x0b,gro); //(0x0b- SCI_VOL)
}

void eepromw() //   EEPROM
{
delay_ms(100);
soft_i2c_start();     //    i2c
soft_i2c_write(0xa0); //1010+ 24LC02B(000)+   (0)
soft_i2c_write(0x00); //      
soft_i2c_write(ntr1); //        (0x00)
soft_i2c_write(rp);   //       (0x01)
soft_i2c_write(grn);  //        (0x02)
soft_i2c_write(bl1);  //          (0x03)
soft_i2c_write(ssa);  //  .  (0x04)
soft_i2c_write(mma);  //  .  (0x05)
soft_i2c_write(ssp);  //  . (0x06)
soft_i2c_write(mmp);  //  . (0x07)
soft_i2c_stop();

delay_ms(100);
soft_i2c_start();
soft_i2c_write(0xa0);
soft_i2c_write(0x08);
soft_i2c_write(rz2<<0);  //1    (0x08)
soft_i2c_write(rz2>>8);  //2    (0x09)
soft_i2c_write(rz2>>16); //3    (0x0a)
soft_i2c_write(rz2>>24); //4    (0x0b)
soft_i2c_write(rzp<<0);  //1    (0x0c)
soft_i2c_write(rzp>>8);  //2    (0x0d)
soft_i2c_write(rzp>>16); //3    (0x0e)
soft_i2c_write(rzp>>24); //4    (0x0f)
soft_i2c_stop();
}

void vikl(unsigned short vk1) // 
{
vs1053wrn(0x0b,0xfefe); vs1053wrn(0x00,0x8808); lcd_cmd(_lcd_turn_off); rzp=rz2-rz1; eepromw(); pd1=0; pd2=0; portb.b3=0; if (vk1==0) while(re0_bit==0); portc=0x00;
}

void eepromr() //   EEPROM
{
delay_ms(10);
soft_i2c_start();       //    i2c
soft_i2c_write(0xa0);   //1010+ 24LC02B(000)+   (0)
soft_i2c_write(0x00);   //      
soft_i2c_start();
soft_i2c_write(0xa1);   //1010+ 24LC02B(000)+  (1)
ntr1=soft_i2c_read(1);  //        (0x00)
rp=  soft_i2c_read(1);  //       (0x01)
grn= soft_i2c_read(1);  //        (0x02)
bl1= soft_i2c_read(1);  //          (0x03)
ssa= soft_i2c_read(1);  //  .  (0x04)
mma= soft_i2c_read(1);  //  .  (0x05)
ssp= soft_i2c_read(1);  //  . (0x06)
mmp= soft_i2c_read(1);  //  . (0x07)
au[0]=soft_i2c_read(1); //1    (0x08)
au[1]=soft_i2c_read(1); //2    (0x09)
au[2]=soft_i2c_read(1); //3    (0x0a)
au[3]=soft_i2c_read(1); //4    (0x0b)
au[4]=soft_i2c_read(1); //1    (0x0c)
au[5]=soft_i2c_read(1); //2    (0x0d)
au[6]=soft_i2c_read(1); //3    (0x0e)
au[7]=soft_i2c_read(0); //4    (0x0f)
soft_i2c_stop();        //    i2c
delay_ms(10);
zt=(au[3]*256)+au[2]; sl=(au[1]*256)+au[0]; rz2=(zt*65536)+sl; // 
zt=(au[7]*256)+au[6]; sl=(au[5]*256)+au[4]; rzp=(zt*65536)+sl; //   

if (grn>100 && bl1>10) {ntr1=1; rp=0; grn=72; bl1=10;} //    EEPROM
}

void akkraz(unsigned short ws1) //           5 
{
if (ws1==1) {vs1053wrn(0x0b,0xfefe); vs1053wrn(0x00,0x8808);} ssv1=0; pd1=0; pd2=1;
tx2[0]=0xa0;tx2[1]=0x61;tx2[2]=0xbf;tx2[3]=0x61;tx2[4]=0x70;tx2[5]=0x65;tx2[6]=0xc7;tx2[7]=0x20;tx2[8]=0x20;tx2[9]=0x20;tx2[10]=0x20;tx2[11]=0x20; stroka(1); //""
tx2[0]=0x20;tx2[1]=0x20;tx2[2]=0x20;tx2[3]=0x50;tx2[4]=0x61;tx2[5]=0xb7;tx2[6]=0x70;tx2[7]=0xc7;tx2[8]=0xb6;tx2[9]=0x65;tx2[10]=0xbd;tx2[11]=0x61; stroka(2); //""
delay_ms(5000); if (ws1==1) vikl(1); else {lcd_cmd(_lcd_turn_off); portc=0x00;}
}

void zaryd() //     
{
if (re1_bit==1 && nb1<755 && zr1==0) {zr1=1;  portc.b2=1; znakbat(1); lcd_chr(1,12,0x07); pd1=0; pd2=1;} //      
if (re1_bit==0 && zr1==1) {zr1=0; portc.b2=0; znakbat(0); lcd_chr(1,12,0x07); pd1=0; pd2=1;} //    
if (zr1==1) ssv2=0; if (nb2==115 && zr1==1) portc.b2=0; //    0,5 
if (nb2>115) //  
{
nb1=adc_read(7); if (nb1<655) akkraz(1);
if (nb1>774 && zr1==1) {zr1=0; znakbat(0); lcd_chr(1,12,0x07); pd1=0; pd2=1;} //      ~4,12 
if (zr1==1) portc.b2=1; nb2=0;
}
}

void osh() {tx2[0]=0x20;tx2[1]=0x20;tx2[2]=0x20;tx2[3]=0x4f;tx2[4]=0xc1;tx2[5]=0xb8;tx2[6]=0xb2;tx2[7]=0x06;tx2[8]=0x61;tx2[9]=0x20;tx2[10]=0x20;tx2[11]=0x20; stroka(1);} // ""

void bukv() //  ",,,,,k"
{
for (i1=64; i1<104; i1=i1+8)
{
tx2[7]=0;
if (i1==64) {tx2[0]=16; tx2[1]=16; tx2[2]=16; tx2[3]=30; tx2[4]=17; tx2[5]=17; tx2[6]=30;} // "" ( 0x00)
if (i1==72) {tx2[0]=0;  tx2[1]=0;  tx2[2]=30; tx2[3]=17; tx2[4]=30; tx2[5]=17; tx2[6]=30;} // "" ( 0x01)
if (i1==80) {tx2[0]=0;  tx2[1]=4;  tx2[2]=14; tx2[3]=21; tx2[4]=21; tx2[5]=14; tx2[6]=4;}  // "" ( 0x02)
if (i1==88) {tx2[0]=0;  tx2[1]=0;  tx2[2]=16; tx2[3]=16; tx2[4]=30; tx2[5]=17; tx2[6]=30;} // "" ( 0x03)
if (i1==96) {tx2[0]=16; tx2[1]=16; tx2[2]=17; tx2[3]=18; tx2[4]=28; tx2[5]=18; tx2[6]=17;} // "k" ( 0x04)
lcd_cmd(i1); for (i2=0; i2<8; i2++) lcd_chr_cp(tx2[i2]); lcd_cmd(_lcd_return_home);
}
}

void id3v1() //  ""          
{
lcd_cmd(_lcd_clear); mmc_fat_seek(rz2-128); //     (   128 )
for (i1=0; i1<40; i1++) {im1[i1]=0x20; im2[i1]=0x20;} tx1[0]=0; tx1[1]=30; tx1[2]=0; tx1[3]=30; a3=0; asm clrwdt;
spi1_init_advanced(_SPI_MASTER_OSC_DIV4,_SPI_DATA_SAMPLE_MIDDLE,_SPI_CLK_IDLE_LOW,_SPI_LOW_2_HIGH);
mmc_fat_read(&tx2[0]);mmc_fat_read(&tx2[1]);mmc_fat_read(&tx2[2]); if (tx2[0]=='T' && tx2[1]=='A' && tx2[2]=='G') a3=1; //   TAG
for (i1=0; i1<30; i1++) {mmc_fat_read(im2+i1); if (im2[i1]==0x00) {im2[i1]=0x20; if (tx1[0]==0) {tx1[1]=i1; tx1[0]=1;}}} // 
for (i1=0; i1<30; i1++) {mmc_fat_read(im1+i1); if (im1[i1]==0x00) {im1[i1]=0x20; if (tx1[2]==0) {tx1[3]=i1; tx1[2]=1;}}} // 
spi1_init_advanced(_SPI_MASTER_OSC_DIV16,_SPI_DATA_SAMPLE_MIDDLE,_SPI_CLK_IDLE_LOW,_SPI_LOW_2_HIGH); for (i1=0; i1<4; i1++) vs1053wr32(au+i3*32);
mmc_fat_seek(rz2-rz1); //     
bukv(); asm clrwdt;

if (a3==0 || (tx1[1]==0 && tx1[3]==0)) // TAG        ,   
{
tx1[1]=12; tx1[3]=12;
im1[0]=0x48;im1[1]=0x65;im1[2]=0x20;im1[3]=0xb7;im1[4]=0x61;im1[5]=0xbe;im1[6]=0x6f;im1[7]=0xbb;im1[8]=0xbd;im1[9]=0x65;im1[10]=0xbd;im1[11]=0x6f; //" "
for (i1=0; i1<12; i1++) im2[i1]=im1[i1];
}

for (i1=0; i1<30; i1++) //  ,     
{
if (im1[i1]==0xa8) im1[i1]=0xa2; if (im2[i1]==0xa8) im2[i1]=0xa2; //''
if (im1[i1]==0xb8) im1[i1]=0xb5; if (im2[i1]==0xb8) im2[i1]=0xb5; //''
if (im1[i1]==0x6b) im1[i1]=0x04; if (im2[i1]==0x6b) im2[i1]=0x04; //'k'
if (im1[i1]>191) im1[i1]=hds[im1[i1]-192]; if (im2[i1]>191) im2[i1]=hds[im2[i1]-192];
}

for (i1=0; i1<12; i1++) {lcd_chr(1,i1+1,im1[i1]); lcd_chr(2,i1+1,im2[i1]);} //  12 
if (tx1[1]>tx1[3]) tx1[3]=tx1[1]; else tx1[1]=tx1[3]; tx1[1]=tx1[1]+9; //     
delay_ms(4000); i1=0; i2=10; ssv1=0; tx1[0]=13; tx1[2]=12;
do
{
if (i2>9) //   0,5  (  )
{
if ((tx1[3])>12) {lcd_chr(1,tx1[0],im1[tx1[2]]); lcd_chr(2,tx1[0],im2[tx1[2]]); lcd_cmd(_lcd_shift_left);}
tx1[0]++; if (tx1[0]>40) tx1[0]=1; tx1[2]++; if (tx1[2]>tx1[1]) tx1[2]=0; i2=0; asm clrwdt;
} 
i2++; delay_ms(50); if (rb6_bit==0) {i1++; pd1=0; pd2=1; ssv2=0;} else i1=0;
if (rb1_bit==0 || rb0_bit==0 || re3_bit==0 || rb2_bit==0 || rb7_bit==0) {pd1=0; pd2=1; ssv2=0;} 
zaryd(); if (ssv2>100) vikl(1); if (re0_bit==1) {ssv1++; pd1=0; pd2=1; ssv2=0;} else ssv1=0;
if (ssv1>20 && ktr!=1) // 
{
lcd_cmd(_lcd_clear);
tx2[0]=0xa9;tx2[1]=0xe3;tx2[2]=0x61;tx2[3]=0xbb;tx2[4]=0xb8;tx2[5]=0xbf;tx2[6]=0x03;tx2[7]=0x20;tx2[8]=0x20;tx2[9]=0x20;tx2[10]=0x20;tx2[11]=0x20; stroka(1); //""
tx2[0]=0x20;tx2[1]=0x20;tx2[2]=0x20;tx2[3]=0x20;tx2[4]=0x20;tx2[5]=0x20;tx2[6]=0x20;tx2[7]=0x02;tx2[8]=0x61;tx2[9]=0xa6;tx2[10]=0xbb;tx2[11]=0x3f; stroka(2); //""
ssv1=0; 
do 
{
ssv1++; delay_ms(50); if (rb1_bit==0 || rb0_bit==0 || re3_bit==0 || rb2_bit==0 || rb7_bit==0 || rb6_bit==0) {dl1=1; rz1=0; p3=0; rp=2; ssv1=100;}
} 
while(ssv1<100); ssv1=0; i1=20;
}
}
while(i1<20);
lcd_cmd(_lcd_clear); ssv2=0; znak(); i2=grn; i2=i2/4; for (i1=1; i1<i2+1; i1++) znakgr(i1); 
if (dl1==0) menu0(); else {tx2[0]=0x20;tx2[1]=0x20;tx2[2]=0xa9;tx2[3]=0xe3;tx2[4]=0x61;tx2[5]=0xbb;tx2[6]=0x65;tx2[7]=0xbd;tx2[8]=0xb8;tx2[9]=0x65;tx2[10]=0x20;tx2[11]=0x20; stroka(1);} //""
}


void main()
{
adcon1=0x0f; cmcon=0x07; porta=0x00; trisa=0xff; portb=0x08; trisb=0xc7; portc=0x40; trisc=0x00; portd=0x00; trisd=0x52; porte=0x00; trise=0x0f;
intcon=0xa0; intcon2=0x04; intcon3=0x00; t0con=0x87; tmr0h=0xf0; tmr0l=0x5f;
lcd_init(); lcd_cmd(_lcd_clear); lcd_cmd(_lcd_cursor_off); // 
soft_i2c_init(); // i2c
adc_init(); //  (RE2  ,     )
nb1=adc_read(7); if (nb1<655 && re1_bit==0) akkraz(0); //   
eepromr();  //     EEPROM
znak();     //       
vs1053in(); // vs1053
gromk();    //   
i2=grn; i2=i2/4; for (i1=1; i1<i2+1; i1++) znakgr(i1); //  
tm1=0;i3=0;nkn=0;tma1=0;tm1=0;sl=0;grs1=0;grs2=0;av1=0;am1=0;ntr2=0;ntr3=0;kp1=0;i1=0;ssv1=0;ssv2=0;nb2=0;ktr=0;kp2=0;ntr4[0]=ntr1;
p1=0;p2=0;st1=0;gr1=0;gr2=0;dct=0;tma2=0;av2=0;am2=0;p3=0;a1=0;bl2=0;ssv3=0;ob1=1;zr1=0;a2=0;a3=0;dl1=0;dl1=0;

if (rd4_bit==0) //  ,     
{
osh();
tx2[0]=0x4b;tx2[1]=0x61;tx2[2]=0x70;tx2[3]=0xbf;tx2[4]=0x61;tx2[5]=0x20;tx2[6]=0xbe;tx2[7]=0x61;tx2[8]=0xbc;tx2[9]=0xc7;tx2[10]=0xbf;tx2[11]=0xb8; stroka(2); //" "
delay_ms(5000); lcd_cmd(_lcd_turn_off); portc=0x00; // 
}

for (i1=0; i1<8; i1++) dir[i1]=0x20; if (mmc_fat_init()==0) {i1=0; a2=1; mmc_fat_dir(printchar);} dir[8]=0x00; //  

if (a3==0 && dir[0]==0x20) //    ,     
{
osh(); 
tx2[0]=0x48;tx2[1]=0x65;tx2[2]=0xbf;tx2[3]=0x20;tx2[4]=0x06;tx2[5]=0x61;tx2[6]=0xbf;tx2[7]=0x61;tx2[8]=0xbb;tx2[9]=0x6f;tx2[10]=0xb4;tx2[11]=0x61; stroka(2); //" "
delay_ms(5000); lcd_cmd(_lcd_turn_off); portc=0x00; // 
}

if (mmc_fat_init()==0 && mmc_fat_changedir(&dir)==0) {i1=0; zt=0; a2=0; a3=1; mmc_fat_dir(printchar);} //    
if (ktr==0) //  MP3   ,     
{
bukv(); osh();
tx2[0]=0x20;tx2[1]=0x48;tx2[2]=0x65;tx2[3]=0xbf;tx2[4]=0x20;tx2[5]=0x02;tx2[6]=0x61;tx2[7]=0xa6;tx2[8]=0xbb;tx2[9]=0x6f;tx2[10]=0x01;tx2[11]=0x20; stroka(2); //" "
delay_ms(5000); lcd_cmd(_lcd_turn_off); portc=0x00; // 
}

pd1=0;pd2=1;
do
{
if (mmc_fat_init()==0 && rd4_bit==1) //    
{
zt=0xfefe; p3=1;

if (dl1==1 && mmc_fat_changedir(&dir)==0 && mmc_fat_assign(&tx2,0) && mmc_fat_delete()==0) {ktr=0; i1=0; zt=0; a2=0; a3=1; mmc_fat_dir(printchar); rp=0; p1=1; perek(); dl1=0; pd1=0; pd2=1;} // 
if (ntr1>ktr || ntr1==0) ntr1=1;

i3=(ntr1-1)*8; for (i1=0; i1<8; i1++) tx2[i1]=naz[i3+i1]; tx2[8]=0x2e; tx2[9]=0x4d; tx2[10]=0x50; tx2[11]=0x33; tx2[12]=0x00; //  (tx2[12]=0x00 -  )
i2=10; for (i1=0; i1<8; i1++) {if (tx2[i1]==0x20) i2=i1;} if (i2!=10) {for (i1=0; i1<i2; i1++) tx2[i1]=0x20;} //     8 

if (mmc_fat_changedir(&dir)==0 && mmc_fat_assign(&tx2,0)) //  
{
mmc_fat_reset(&rz1); // 
if (rz1!=rz2) {if (ob1==1) {mma=0; ssa=0;} ssp=0; mmp=0; rzp=0; rz2=rz1;} else {rz1=rz2-rzp; mmc_fat_seek(rzp); vs1053wrn(0x0b,0xfefe); gr2=1;}
menu0(); tma1=38;
sso=mmp*60+ssp; vs1053wrn(0x04,sso); //             
while (rz1>512) //   512     vs1053
{
zaryd(); //     
if (rd4_bit==1) asm clrwdt; else {if (st1==1) rz1=513; else rz1=0; pd1=0; pd2=1;} //     

if (dct==1 && av2==0 && am2==0) //   SCI_DECODE_TIME    
{
vs1053rd(0x04); sso=(rg2<<8)+rg1; mmp=sso/60; ssp=sso-mmp*60;
if (sso!=0)
{if (ssp==0) {bytetostr(mmp,tx1); if (tx1[1]==0x20) tx1[1]=0x30; lcd_chr(2,1,tx1[1]); lcd_chr(2,2,tx1[2]);}
              bytetostr(ssp,tx1); if (tx1[1]==0x20) tx1[1]=0x30; lcd_chr(2,4,tx1[1]); lcd_chr(2,5,tx1[2]);}
dct=0;
}

if (st1==1 && av2==0 && am2==0) // 
{
if (grn!=0) ssv2=0; //     
if (tma1>39 && tma2==1) //   SCI_HDAT0        
{
if (tma1==40) {vs1053rd(0x08); rg2=rg2>>4; rg2=bitr[rg2-1]; rzs=rg2*1000; rzd=rz2/rzs; mma=rzd/60; ssa=rzd-mma*60;}
if (tma1==42) {bytetostr(ssa,tx1); if (tx1[1]==0x20) tx1[1]=0x30; lcd_chr(2,11,tx1[1]); lcd_chr(2,12,tx1[2]);}
if (tma1==44) {bytetostr(mma,tx1); if (tx1[1]==0x20) tx1[1]=0x30; lcd_chr(2,8, tx1[1]); lcd_chr(2,9,tx1[2]); tma1=0;}
tma2=0;
}
spi1_init_advanced(_SPI_MASTER_OSC_DIV4,_SPI_DATA_SAMPLE_MIDDLE,_SPI_CLK_IDLE_LOW,_SPI_LOW_2_HIGH);  for (i3=0; i3<512; i3++) mmc_fat_read(au+i3); //   SD    
spi1_init_advanced(_SPI_MASTER_OSC_DIV16,_SPI_DATA_SAMPLE_MIDDLE,_SPI_CLK_IDLE_LOW,_SPI_LOW_2_HIGH); for (i3=0; i3<16; i3++) vs1053wr32(au+i3*32); //   vs1053
rz1=rz1-512; //       vs1053
if (gr2==1) {zt=zt-4000; if (zt<4000) zt=0; if (zt<=gro) {gromk(); gr2=0; zt=0;}} //  
}

if (ssv2>100) vikl(1); //       (1 )

if (nkn==1) //  (  0,125 )
{
if (rb1_bit==0) // 
{grs1++; if (grs1==1 || grs1>3) {gr1=1;pd1=0;pd2=1;grs1=1; if (bl2==0) {grn=grn+4; if (grn>100) grn=100;} else {bl1++; if (bl1>20) bl1=20;}}} else grs1=0;

if (rb0_bit==0) // 
{grs2++; if (grs2==1 || grs2>3) {gr1=1;pd1=0;pd2=1;grs2=1; if (bl2==0) {grn=grn-4; if (grn>100) grn=0;}   else {bl1--; if (bl1>20) bl1=0;}}}  else grs2=0;

if (gr1==1) {if (bl2==0) {i2=grn; i2=i2/4; znakgr(i2); lcd_chr(1,11,0x05);} else znakbl(); gromk(); gr1=0;} // 

if (re3_bit==1 && kp1>0 && kp1<6) {if (bl2==0) {rp++; if (rp>2) rp=0; lcd_chr(1,10,rp+2);} pd1=0; pd2=1;} //  
if (re3_bit==0) {kp1++; if (kp1==20) {bl2=~bl2; if (bl2==0) {lcd_chr(1,10,rp+2); lcd_chr(1,11,0x05);} else znakbl();} pd1=0; pd2=1;} else kp1=0; //   

if (rb2_bit==1 && av1>0 && av1<6) {p1=1; gr2=1; vs1053wrn(0x0b,0xfefe); perek(); pd1=0; pd2=1; p3=0;} // 
if (rb2_bit==0) {a1=1; av1++;if (av1>250) av1=250;pd1=0;pd2=1;av2=1;if (av1>9 && (mma!=0 || ssa!=0)) prib();} else {av1=0;if (av2==1) {f1();av2=0;}} // 

if (rb7_bit==1 && am1>0 && am1<6) {p2=1; gr2=1; vs1053wrn(0x0b,0xfefe); perek(); pd1=0; pd2=1; p3=0;} // 
if (rb7_bit==0) {a1=1; am1++;if (am1>250) am1=250;pd1=0;pd2=1;am2=1;if (am1>9 && (mma!=0 || ssa!=0)) prib();} else {am1=0;if (am2==1) {f1();am2=0;}} // 

if (rb6_bit==1 && kp2>0 && kp2<6) ///
{
st1=~st1; pd1=0; pd2=1; tma1=38; znakvsp(); lcd_chr(2,6,0x00); lcd_chr(2,7,0x01); znakbat(zr1); lcd_chr(1,12,0x07);
if (st1==0) {vs1053wrn(0x0b,0xfefe); vs1053wrn(0x00,0x8808);} else {gr2=1; zt=0xfefe; vs1053wrn(0x00,0x8800);}
}
if (rb6_bit==0) {kp2++; if (kp2==20 && st1==0) {pd1=0; pd2=1; id3v1();}} else kp2=0; //        

if (re0_bit==0) ssv3=1; if (re0_bit==1) {ssv1++; pd1=0; pd2=1;} else ssv1=0; if (ssv1>30 && ssv3==1) vikl(0); // 
nkn=0;
}
}

spi1_init_advanced(_spi_master_osc_div4 ,_spi_data_sample_middle,_spi_clk_idle_low,_spi_low_2_high); for (i3=0; i3<rz1; i3++) mmc_fat_read(au+i3); //   SD    
spi1_init_advanced(_spi_master_osc_div16,_spi_data_sample_middle,_spi_clk_idle_low,_spi_low_2_high); for (i3=0; i3<rz1; i3++)   vs1053wr1(au[i3]); //   vs1053

if (p3==1) {p1=1; perek();} //      
}
}
else
{
//SD     
osh();
tx2[0]=0x4b;tx2[1]=0x61;tx2[2]=0x70;tx2[3]=0xbf;tx2[4]=0x61;tx2[5]=0x20;tx2[6]=0xbe;tx2[7]=0x61;tx2[8]=0xbc;tx2[9]=0xc7;tx2[10]=0xbf;tx2[11]=0xb8; stroka(2); //" "
delay_ms(5000); lcd_cmd(_lcd_turn_off); portc=0x00; // 
}

}
while(1);
}